classification
Title: descriptor protocol documentation has two different definitions of "owner" class
Type: Stage:
Components: Documentation Versions: Python 3.1, Python 3.2, Python 3.3, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: rhettinger Nosy List: Devin Jeanpierre, docs@python, python-dev, rhettinger, terry.reedy
Priority: normal Keywords:

Created on 2010-12-25 05:05 by Devin Jeanpierre, last changed 2011-03-23 00:52 by python-dev. This issue is now closed.

Files
File name Uploaded Description Edit
descriptor.py.doctest Devin Jeanpierre, 2010-12-25 05:05 doctest file demonstrating the error
Messages (5)
msg124630 - (view) Author: Devin Jeanpierre (Devin Jeanpierre) * Date: 2010-12-25 05:05
In trunk/Doc/reference/datamodel.rst , under _Implementing Descriptors_, the documentation states: 

`The following methods only apply when an instance of the class containing the method (a so-called *descriptor* class) appears in the class dictionary of another new-style class, known as the *owner* class. [...]`

Immediately below, in the documentation for __get__, it says, `*owner* is always the owner class [...]`.

These two uses of "the owner class" are incompatible, because there is only one class which matches the first use: the class where the descriptor was initially assigned to a class attribute; however, for the second use, any descendant class may be called "the owner class". This is demonstrated in the attached doctest file.

It is kind of hard to create a better definition for "owner" as used in `__get__`, though. It can't be said to be the class with the descriptor in its class dict, because it can be present in the class dict of some class in the MRO of the owner. It can't be said to be an attribute, because it has to be in a class dict of an ancestor node.

It might be possible to change the definition to call the owner class something like, "the class from which the descriptor was invoked", and if that isn't clear enough, provide examples (TypeDescriptor from the attached doctest file might work as an example); however, this would involve reworking the structure of the paragraph substantially. I personally would prefer this option. The paragraph is already badly structured; for example, it defines two terms in a single and rather complex sentence, and should probably be split up into a list of definitions rather than an explanatory jumble paragraph. In addition, this paragraph is the only place in the documentation where this idea of "the owner class" is used in this way. In the descriptions of the descriptor protocol methods below it, "the owner class" always refers to the class from which the attribute was accessed, or the type from which an instance had the attribute accessed.

Alternatively, it could be simpler to replace all references below from "the owner class" to "any class with the owner class in the MRO".
msg124706 - (view) Author: Raymond Hettinger (rhettinger) * (Python committer) Date: 2010-12-27 09:32
I agree that the "owner" terminology imprecise.
Will work on a doc fix when I get chance.
msg124979 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2010-12-31 22:33
For future reference, the 'trunk' branch was frozen with the release of 2.7 in June 2010. However, this particular text is unchanged since in 2.7.1 and still in 3.2b2 (except for removal of 'new style'.)
msg131810 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2011-03-22 23:28
New changeset b31606ea7ce3 by Raymond Hettinger in branch '3.1':
Issue #10771: Clarify that descriptors get used in an *owner* class or one of its parents.
http://hg.python.org/cpython/rev/b31606ea7ce3

New changeset 4dfbf8c8f4e5 by Raymond Hettinger in branch '3.2':
Issue #10771: Clarify that descriptors get used in an *owner* class or one of its parents.
http://hg.python.org/cpython/rev/4dfbf8c8f4e5

New changeset 5aaa71591dda by Raymond Hettinger in branch 'default':
Issue #10771: Clarify that descriptors get used in an *owner* class or one of its parents.
http://hg.python.org/cpython/rev/5aaa71591dda
msg131830 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2011-03-23 00:52
New changeset f28565867d22 by Raymond Hettinger in branch '2.7':
Issue #10771: Clarify that descriptors get used in an *owner* class or one of its parents.
http://hg.python.org/cpython/rev/f28565867d22
History
Date User Action Args
2011-03-23 00:52:31python-devsetnosy: rhettinger, terry.reedy, Devin Jeanpierre, docs@python, python-dev
messages: + msg131830
2011-03-22 23:29:08rhettingersetstatus: open -> closed
nosy: rhettinger, terry.reedy, Devin Jeanpierre, docs@python, python-dev
resolution: fixed
versions: + Python 3.1, Python 3.2, Python 3.3
2011-03-22 23:28:19python-devsetnosy: + python-dev
messages: + msg131810
2010-12-31 22:33:02terry.reedysetnosy: + terry.reedy
messages: + msg124979
2010-12-27 09:32:22rhettingersetassignee: docs@python -> rhettinger

messages: + msg124706
nosy: + rhettinger
2010-12-25 05:05:50Devin Jeanpierrecreate